/* 
 *  StreamDetector.h: implementation of the CStreamDetector class.
 *
 *	Copyright (C) Alberto Vigata - January 2000 - ultraflask@yahoo.com
 *
 *  This file is part of FlasKMPEG, a free MPEG to MPEG/AVI converter
 *	
 *  FlasKMPEG is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2, or (at your option)
 *  any later version.
 *   
 *  FlasKMPEG is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *   
 *  You should have received a copy of the GNU General Public License
 *  along with GNU Make; see the file COPYING.  If not, write to
 *  the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA. 
 *
 */
#if !defined(AFX_STREAMDETECTOR_H__A14A6D0E_CDF4_11D3_94E2_00000100CF13__INCLUDED_)
#define AFX_STREAMDETECTOR_H__A14A6D0E_CDF4_11D3_94E2_00000100CF13__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "inputstream.h"
#include "..\Demux\demux.h"

struct TStreamIdentifier
{
	int		streamID;  		    //Stream ID
	int		subStreamID;        //SubStream ID
	int		aux;				//auxiliary data
	char    id[256];			//MobId

};
#define MAX_AUDIO_STREAMS 8

class TStreamDetector
{
	public:
		int AddST( TStreamIdentifier *si );
		TStreamDetector();
		~TStreamDetector();
		TStreamIdentifier *video;
		TStreamIdentifier *audio;
		TStreamIdentifier *subpic;
		int				  n_video_streams;
		int				  n_audio_streams;
		int				  n_subpic_streams;
		
		int				  n_audio_selected;
		int				  audio_selected[MAX_AUDIO_STREAMS];
	
		int				  video_selected;
		int				  subpic_selected;
};


class CStreamDetector  
{
	public:
	 CStreamDetector();
	~CStreamDetector();
	int RecognizeType();
	int GetStreams(TStreamDetector *st, int lurk_size);
	int SetFile(char *inputfile);



private:
	//  FindStream variables
	bool		FSstreamFound;
	int			FSstreamID;
	int			FSsubstreamID;
	int			FStype;       // 0: video , 1:audio
	char 		FSszReport[256];


	CinputStream    *inp;



};

#endif // !defined(AFX_STREAMDETECTOR_H__A14A6D0E_CDF4_11D3_94E2_00000100CF13__INCLUDED_)
