/* 
 *  Plugins.h
 *
 *	Copyright (C) Alberto Vigata - January 2000 - ultraflask@yahoo.com
 *
 *  This file is part of FlasKMPEG, a free MPEG to MPEG/AVI converter
 *	
 *  FlasKMPEG is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2, or (at your option)
 *  any later version.
 *   
 *  FlasKMPEG is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *   
 *  You should have received a copy of the GNU General Public License
 *  along with GNU Make; see the file COPYING.  If not, write to
 *  the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA. 
 *
 */


#ifndef PLUGINS_H
#define PLUGINS_H

#define MAX_OUT_PLUGINS  20
#define OUT_PLUG_MEM     4096
#include <windows.h>

struct TOutPlugin
{
	HINSTANCE			hinstLib;
	CompileEntryFunc	CompileEntry;
	int                 CompilerID;
	int                 fileType;
	char                ID[256];
	char                *settings;
};

struct TPlugins
{
	int         OutPluginCount;
	TOutPlugin  outPlugs[MAX_OUT_PLUGINS];
};

int LoadPlugins( TPlugins *plugs );
int SaveSettings(TPlugins *plugs, int current, char *name);
int FlushPluginSettings( TPlugins *plugs );
int ClosePlugins(TPlugins *plugs);

#endif