#ifndef PREMIERE_H
#define PREMIERE_H

char *fnewPtr( long size );
long fsetPtrSize ( char *ptr, long newsize );
long fgetPtrSize ( char *ptr );
void fdisposePtr( char *ptr );

int fsetClassData ( long theClass, long info );
long fgetClassData ( long theClass );

int fgetAudio ( long frame, long *frameCount, long *size, long offset, BufferReturnType theBuffer, long compileSeqID );
long fgetBlipMax ( long compileSeqID );

int fgetFrame ( long frame, void **buffer, long *rowbytes, compGetFrameReturnRec *getFrameReturn, char getCompressed, long compileSeqID );
int fgetFrameInfo ( long frame, compFrameInfoRec *frameInfo, long compileSeqID );
compHistogramPtr fhistogramInit ( void );
void fhistogramFree ( compHistogramPtr histogram );
int fhistogramProcessPixels ( compHistogramFrameInfoRec *histogramInfo, compHistogramPtr histogram );
compPalette fhistogramToPalette ( compHistogramPtr histogram, char *lp16to8, int nColors );
void fhistogramDisposePalette ( compPalette palette );
void fhistogramReducePixels( compPixelInfoRec *histogramPixelInfo, compPalette palette, char *lp16to8 );

void fstartDebug( long playID );
void fdebugStr( long playID, char *cstr );

char** fnewHandle ( long size );
short fsetHandleSize ( char **Handle, long newsize );
long fgetHandleSize ( char **Handle );
void fdisposeHandle ( char **Handle );
void f2setPtrSize ( char **ptr, long newsize );

void fupdateAllWindows (void);
long fgetMainWnd (void);

char* fppixGetPixels ( PPixHand pix );
void fppixGetBounds ( PPixHand pix, prRect* bounds );
int fppixGetRowbytes ( PPixHand pix );

long fgetInfoChunkSize( int chunkID );
void fgetInfoChunk( int chunkID, void *buffer );

void fsetProgressStr( char *ptr, long compileSeqID );
int fupdateProgress( long frame, long compileSeqID );

long fgetSettings (long settingsSelector);
#endif