	.586
	.mmx
	.model flat

	.data

;This code is based on the fragments from the Intel Application Note AP-922.
;
;Apologies to Intel; Adobe Acrobat screws up formatting royally.

;=============================================================================
;
; These examples contain code fragments for first stage iDCT 8x8
; (for rows) and first stage DCT 8x8 (for columns)
;
;=============================================================================

mword	typedef	qword
mptr	equ	mword ptr

BITS_INV_ACC	= 4			; 4 or 5 for IEEE
SHIFT_INV_ROW	= 16 - BITS_INV_ACC
SHIFT_INV_COL	= 1 + BITS_INV_ACC
RND_INV_ROW	= 1024 * (6 - BITS_INV_ACC) ; 1 << (SHIFT_INV_ROW-1)
RND_INV_COL	= 16 * (BITS_INV_ACC - 3) ; 1 << (SHIFT_INV_COL-1)
RND_INV_CORR	= RND_INV_COL - 1 ; correction -1.0 and round

		.data
		Align	16

one_corr	sword	1, 1, 1, 1
round_inv_row	dword	RND_INV_ROW, RND_INV_ROW
round_inv_col	sword	RND_INV_COL, RND_INV_COL, RND_INV_COL, RND_INV_COL
round_inv_corr	sword	RND_INV_CORR, RND_INV_CORR, RND_INV_CORR, RND_INV_CORR
tg_1_16		sword	13036, 13036, 13036, 13036	; tg * (2<<16)
tg_2_16		sword	27146, 27146, 27146, 27146	; tg * (2<<16)
tg_3_16		sword	-21746, -21746, -21746, -21746	; tg * (2<<16) - 1.0
cos_4_16	sword	-19195, -19195, -19195, -19195	; cos * (2<<16) - 1.0
ocos_4_16	sword	23170, 23170, 23170, 23170	; cos * (2<<15) + 0.5

;=============================================================================
;
; The first stage iDCT 8x8 - inverse DCTs of rows
;
;-----------------------------------------------------------------------------
; The 8-point inverse DCT direct algorithm
;-----------------------------------------------------------------------------
;
; static const short w[32] = {
; FIX(cos_4_16), FIX(cos_2_16), FIX(cos_4_16), FIX(cos_6_16),
; FIX(cos_4_16), FIX(cos_6_16), -FIX(cos_4_16), -FIX(cos_2_16),
; FIX(cos_4_16), -FIX(cos_6_16), -FIX(cos_4_16), FIX(cos_2_16),
; FIX(cos_4_16), -FIX(cos_2_16), FIX(cos_4_16), -FIX(cos_6_16),
; FIX(cos_1_16), FIX(cos_3_16), FIX(cos_5_16), FIX(cos_7_16),
; FIX(cos_3_16), -FIX(cos_7_16), -FIX(cos_1_16), -FIX(cos_5_16),
; FIX(cos_5_16), -FIX(cos_1_16), FIX(cos_7_16), FIX(cos_3_16),
; FIX(cos_7_16), -FIX(cos_5_16), FIX(cos_3_16), -FIX(cos_1_16) };
;
; #define DCT_8_INV_ROW(x, y)
;{
; int a0, a1, a2, a3, b0, b1, b2, b3;
;
; a0 =x[0]*w[0]+x[2]*w[1]+x[4]*w[2]+x[6]*w[3];
; a1 =x[0]*w[4]+x[2]*w[5]+x[4]*w[6]+x[6]*w[7];
; a2 = x[0] * w[ 8] + x[2] * w[ 9] + x[4] * w[10] + x[6] * w[11];
; a3 = x[0] * w[12] + x[2] * w[13] + x[4] * w[14] + x[6] * w[15];
; b0 = x[1] * w[16] + x[3] * w[17] + x[5] * w[18] + x[7] * w[19];
; b1 = x[1] * w[20] + x[3] * w[21] + x[5] * w[22] + x[7] * w[23];
; b2 = x[1] * w[24] + x[3] * w[25] + x[5] * w[26] + x[7] * w[27];
; b3 = x[1] * w[28] + x[3] * w[29] + x[5] * w[30] + x[7] * w[31];
;
; y[0] = SHIFT_ROUND ( a0 + b0 );
; y[1] = SHIFT_ROUND ( a1 + b1 );
; y[2] = SHIFT_ROUND ( a2 + b2 );
; y[3] = SHIFT_ROUND ( a3 + b3 );
; y[4] = SHIFT_ROUND ( a3 - b3 );
; y[5] = SHIFT_ROUND ( a2 - b2 );
; y[6] = SHIFT_ROUND ( a1 - b1 );
; y[7] = SHIFT_ROUND ( a0 - b0 );
;}
;
;-----------------------------------------------------------------------------
;
; In this implementation the outputs of the iDCT-1D are multiplied
; for rows 0,4 - by cos_4_16,
; for rows 1,7 - by cos_1_16,
; for rows 2,6 - by cos_2_16,
; for rows 3,5 - by cos_3_16
; and are shifted to the left for better accuracy
;
; For the constants used,
; FIX(float_const) = (short) (float_const * (1<<15) + 0.5)
;
;=============================================================================

; Table for rows 0,4 - constants are multiplied by cos_4_16

tab_i_04	sword 16384, 16384, 16384, -16384 ; movq-> w06 w04 w02 w00
		sword 21407, 8867, 8867, -21407 ; w07 w05 w03 w01
		sword 16384, -16384, 16384, 16384 ; w14 w12 w10 w08
		sword -8867, 21407, -21407, -8867 ; w15 w13 w11 w09
		sword 22725, 12873, 19266, -22725 ; w22 w20 w18 w16
		sword 19266, 4520, -4520, -12873 ; w23 w21 w19 w17
		sword 12873, 4520, 4520, 19266 ; w30 w28 w26 w24
		sword -22725, 19266, -12873, -22725 ; w31 w29 w27 w25

; Table for rows 1,7 - constants are multiplied by cos_1_16

tab_i_17	sword 22725, 22725, 22725, -22725 ; movq-> w06 w04 w02 w00
		sword 29692, 12299, 12299, -29692 ; w07 w05 w03 w01
		sword 22725, -22725, 22725, 22725 ; w14 w12 w10 w08
		sword -12299, 29692, -29692, -12299 ; w15 w13 w11 w09
		sword 31521, 17855, 26722, -31521 ; w22 w20 w18 w16
		sword 26722, 6270, -6270, -17855 ; w23 w21 w19 w17
		sword 17855, 6270, 6270, 26722 ; w30 w28 w26 w24
		sword -31521, 26722, -17855, -31521 ; w31 w29 w27 w25

; Table for rows 2,6 - constants are multiplied by cos_2_16

tab_i_26	sword 21407, 21407, 21407, -21407 ; movq-> w06 w04 w02 w00
		sword 27969, 11585, 11585, -27969 ; w07 w05 w03 w01
		sword 21407, -21407, 21407, 21407 ; w14 w12 w10 w08
		sword -11585, 27969, -27969, -11585 ; w15 w13 w11 w09
		sword 29692, 16819, 25172, -29692 ; w22 w20 w18 w16
		sword 25172, 5906, -5906, -16819 ; w23 w21 w19 w17
		sword 16819, 5906, 5906, 25172 ; w30 w28 w26 w24
		sword -29692, 25172, -16819, -29692 ; w31 w29 w27 w25

; Table for rows 3,5 - constants are multiplied by cos_3_16

tab_i_35	sword 19266, 19266, 19266, -19266 ; movq-> w06 w04 w02 w00
		sword 25172, 10426, 10426, -25172 ; w07 w05 w03 w01
		sword 19266, -19266, 19266, 19266 ; w14 w12 w10 w08
		sword -10426, 25172, -25172, -10426 ; w15 w13 w11 w09
		sword 26722, 15137, 22654, -26722 ; w22 w20 w18 w16
		sword 22654, 5315, -5315, -15137 ; w23 w21 w19 w17
		sword 15137, 5315, 5315, 22654 ; w30 w28 w26 w24
		sword -26722, 22654, -15137, -26722 ; w31 w29 w27 w25

;-----------------------------------------------------------------------------
DCT_8_INV_ROW_1 MACRO INP:REQ, OUT:REQ, TABLE:REQ

		movq		mm0, mptr [INP] ; 0 ; x3 x2 x1 x0

		movq		mm1, mptr [INP+8] ; 1 ; x7 x6 x5 x4
		movq		mm2, mm0 ; 2 ; x3 x2 x1 x0

		movq		mm3, mptr [TABLE] ; 3 ; w06 w04 w02 w00
		punpcklwd	mm0, mm1 ; x5 x1 x4 x0

		movq		mm5, mm0 ; 5 ; x5 x1 x4 x0
		punpckldq	mm0, mm0 ; x4 x0 x4 x0

		movq		mm4, mptr [TABLE+8] ; 4 ; w07 w05 w03 w01
		punpckhwd	mm2, mm1 ; 1 ; x7 x3 x6 x2

		pmaddwd		mm3, mm0 ; x4*w06+x0*w04 x4*w02+x0*w00
		movq		mm6, mm2 ; 6 ; x7 x3 x6 x2

		movq		mm1, mptr [TABLE+32] ; 1 ; w22 w20 w18 w16
		punpckldq	mm2, mm2 ; x6 x2 x6 x2

		pmaddwd		mm4, mm2 ; x6*w07+x2*w05 x6*w03+x2*w01
		punpckhdq	mm5, mm5 ; x5 x1 x5 x1

		pmaddwd		mm0, mptr [TABLE+16] ; x4*w14+x0*w12 x4*w10+x0*w08
		punpckhdq	mm6, mm6 ; x7 x3 x7 x3

		movq		mm7, mptr [TABLE+40] ; 7 ; w23 w21 w19 w17
		pmaddwd		mm1, mm5 ; x5*w22+x1*w20 x5*w18+x1*w16

		paddd		mm3, mptr round_inv_row ; +rounder
		pmaddwd		mm7, mm6 ; x7*w23+x3*w21 x7*w19+x3*w17

		pmaddwd		mm2, mptr [TABLE+24] ; x6*w15+x2*w13 x6*w11+x2*w09
		paddd		mm3, mm4 ; 4 ; a1=sum(even1) a0=sum(even0)

		pmaddwd		mm5, mptr [TABLE+48] ; x5*w30+x1*w28 x5*w26+x1*w24
		movq		mm4, mm3 ; 4 ; a1 a0

		pmaddwd		mm6, mptr [TABLE+56] ; x7*w31+x3*w29 x7*w27+x3*w25
		paddd		mm1, mm7 ; 7 ; b1=sum(odd1) b0=sum(odd0)

		paddd		mm0, mptr round_inv_row ; +rounder
		psubd		mm3, mm1 ; a1-b1 a0-b0

		psrad		mm3, SHIFT_INV_ROW ; y6=a1-b1 y7=a0-b0
		paddd		mm1, mm4 ; 4 ; a1+b1 a0+b0

		paddd		mm0, mm2 ; 2 ; a3=sum(even3) a2=sum(even2)
		psrad		mm1, SHIFT_INV_ROW ; y1=a1+b1 y0=a0+b0

		paddd		mm5, mm6 ; 6 ; b3=sum(odd3) b2=sum(odd2)
		movq		mm4, mm0 ; 4 ; a3 a2

		paddd		mm0, mm5 ; a3+b3 a2+b2
		psubd		mm4, mm5 ; 5 ; a3-b3 a2-b2

		psrad		mm0, SHIFT_INV_ROW ; y3=a3+b3 y2=a2+b2

		psrad		mm4, SHIFT_INV_ROW ; y4=a3-b3 y5=a2-b2

		packssdw	mm1, mm0 ; 0 ; y3 y2 y1 y0

		packssdw	mm4, mm3 ; 3 ; y6 y7 y4 y5

		movq		mm7, mm4 ; 7 ; y6 y7 y4 y5
		psrld		mm4, 16 ; 0 y6 0 y4

		pslld		mm7, 16 ; y7 0 y5 0

		movq		mptr [OUT], mm1 ; 1 ; save y3 y2 y1 y0
		por		mm7, mm4 ; 4 ; y7 y6 y5 y4

		movq		mptr [OUT+8], mm7 ; 7 ; save y7 y6 y5 y4
ENDM


;=============================================================================
;
; The second stage iDCT 8x8 - inverse DCTs of columns
;
; The outputs are premultiplied
; for rows 0,4 - on cos_4_16,
; for rows 1,7 - on cos_1_16,
; for rows 2,6 - on cos_2_16,
; for rows 3,5 - on cos_3_16
; and are shifted to the left for rise of accuracy
;
;-----------------------------------------------------------------------------
;
; The 8-point scaled inverse DCT algorithm (26a8m)
;
;-----------------------------------------------------------------------------
;
;	// Reorder and prescale (implicit)
;
;	ev0 = co[0] / 2.0;
;	ev1 = co[2] / 2.0;
;	ev2 = co[4] / 2.0;
;	ev3 = co[6] / 2.0;
;	od0 = co[1] / 2.0;
;	od1 = co[3] / 2.0;
;	od2 = co[5] / 2.0;
;	od3 = co[7] / 2.0;
;
;	// 5) Apply D8T (implicit in row calculation).
;
;	tmp[0] = ev0*LAMBDA(4);
;	tmp[1] = ev2*LAMBDA(4);
;	tmp[2] = ev1*LAMBDA(2);
;	tmp[3] = ev3*LAMBDA(2);
;	tmp[4] = od0*LAMBDA(1);
;	tmp[5] = od3*LAMBDA(1);
;	tmp[6] = od1*LAMBDA(3);
;	tmp[7] = od2*LAMBDA(3);
;
;	// 4) Apply B8T.
;
;	double x0, x1, x2, x3, y0, y1, y2, y3;
;
;	x0 = tmp[0] + tmp[1];
;	x1 = tmp[0] - tmp[1];
;	x2 = tmp[2] + TAN(2)*tmp[3];
;	x3 = tmp[2]*TAN(2) - tmp[3];
;	y0 = tmp[4] + TAN(1)*tmp[5];
;	y1 = tmp[4]*TAN(1) - tmp[5];
;	y2 = tmp[6] + TAN(3)*tmp[7];
;	y3 = tmp[6]*TAN(3) - tmp[7];
;
;	// 3) Apply E8T.
;	//
;	//	1  0  1  0
;	//	0  1  0  1
;	//	0  1  0 -1
;	//	1  0 -1  0
;	//		    1  0  1  0
;	//		    1  0 -1  0
;	//		    0  1  0  1
;	//		    0  1  0 -1
;
;	double e0, e1, e2, e3, o0, o1, o2, o3;
;
;	e0 = x0 + x2;
;	e1 = x1 + x3;
;	e2 = x1 - x3;
;	e3 = x0 - x2;
;	o0 = y0 + y2;
;	o1 = y0 - y2;
;	o2 = y1 + y3;
;	o3 = y1 - y3;
;
;	// 2) Apply F8T.
;
;	double a, b;
;
;	a = (o1 + o2) * LAMBDA(4);
;	b = (o1 - o2) * LAMBDA(4);
;
;	o1 = a;
;	o2 = b;
;
;	// 6) Apply output butterfly (A8T).
;	//
;	// 1 0 0 0  1  0  0  0
;	// 0 1 0 0  0  1  0  0
;	// 0 0 1 0  0  0  1  0
;	// 0 0 0 1  0  0  0  1
;	// 0 0 0 1  0  0  0 -1
;	// 0 0 1 0  0  0 -1  0
;	// 0 1 0 0  0 -1  0  0
;	// 1 0 0 0 -1  0  0  0
;
;	out[0] = e0 + o0;
;	out[1] = e1 + o1;
;	out[2] = e2 + o2;
;	out[3] = e3 + o3;
;	out[4] = e3 - o3;
;	out[5] = e2 - o2;
;	out[6] = e1 - o1;
;	out[7] = e0 - o0;
;
;=============================================================================
DCT_8_INV_COL_4 MACRO INP:REQ, OUT:REQ
LOCAL	x0, x1, x2, x3, x4, x5, x6, x7
LOCAL	y0, y1, y2, y3, y4, y5, y6, y7

x0	equ	[INP + 0*16]
x1	equ	[INP + 1*16]
x2	equ	[INP + 2*16]
x3	equ	[INP + 3*16]
x4	equ	[INP + 4*16]
x5	equ	[INP + 5*16]
x6	equ	[INP + 6*16]
x7	equ	[INP + 7*16]
y0	equ	[OUT + 0*16]
y1	equ	[OUT + 1*16]
y2	equ	[OUT + 2*16]
y3	equ	[OUT + 3*16]
y4	equ	[OUT + 4*16]
y5	equ	[OUT + 5*16]
y6	equ	[OUT + 6*16]
y7	equ	[OUT + 7*16]

	;======= optimized code

	IF 1

	;ODD ELEMENTS

	movq	mm0,x1		;tmp[4]

	movq	mm1,x7		;tmp[5]
	movq	mm4,mm0

	movq	mm2,x3		;tmp[6]
	movq	mm5,mm1

	movq	mm3,x5		;tmp[7]
	movq	mm6,mm2

	pmulhw	mm6,qword ptr tg_3_16	;tmp[6]*(tan(3pi/16) - 0.5)
	movq	mm7,mm3

	pmulhw	mm7,qword ptr tg_3_16	;tmp[7]*(tan(3pi/16) - 0.5)
	;v

	pmulhw	mm5,qword ptr tg_1_16	;tmp[5]*tan(1pi/16)
	;v

	pmulhw	mm4,qword ptr tg_1_16	;tmp[4]*tan(1pi/16)
	paddw	mm6,mm2		;tmp[6]*tan(3pi/16)

	psubw	mm6,mm3		;mm6 = y3 = tmp[6]*TAN(3) - tmp[7]
	paddw	mm7,mm3		;tmp[7]*tan(3pi/16)

	paddw	mm5,mword ptr one_corr
	paddw	mm2,mm7		;mm2 = y2 = tmp[6] + TAN(3)*tmp[7]

	paddw	mm0,mm5		;mm0 = y0 = tmp[4] + TAN(1)*tmp[5]
	psubw	mm4,mm1		;mm4 = y1 = tmp[4]*TAN(1) - tmp[5]

	;E8T butterfly - odd elements

	movq	mm1,mm0
	movq	mm5,mm4
	paddw	mm0,mm2		;mm0 = o0 = y0 + y2
	psubw	mm1,mm2		;mm1 = o1 = y0 - y2
	paddw	mm4,mm6		;mm4 = o2 = y1 + y3
	psubw	mm5,mm6		;mm5 = o3 = y1 - y3

	;F8T stage - odd elements

	movq	mm2,mm1
	paddw	mm1,mm4		;mm1 = o1 + o2

	psubw	mm2,mm4		;mm2 = o1 - o2
	movq	mm6,mm1

	pmulhw	mm1,qword ptr cos_4_16
	movq	mm7,mm2

	pmulhw	mm2,qword ptr cos_4_16

	por	mm1,mword ptr one_corr

	psubw	mm2,mword ptr one_corr

	paddw	mm1,mm6		;mm1 = o1' = (o1 + o2)*LAMBDA(4)
	paddw	mm2,mm7		;mm2 = o2' = (o1 - o2)*LAMBDA(4)

	;HOLD these registers:
	;
	;	mm0 = o0
	;	mm1 = o1
	;	mm2 = o2
	;	mm5 = o3

	;EVEN ELEMENTS

	;B8T stage - first two even elements

	movq	mm3,x0		;mm3 = tmp[0]
	movq	mm4,mm3
	paddw	mm3,x4		;mm3 = x0 = tmp[0] + tmp[1]
	psubw	mm4,x4		;mm4 = x1 = tmp[0] - tmp[1]
	
	;B8T stage - x2 element

	movq	mm7,x6		;mm7 = tmp[3]
	pmulhw	mm7,qword ptr tg_2_16	;mm7 = tmp[3] * TAN(2)

	paddw	mm7,mword ptr one_corr

	paddw	mm7,x2		;mm7 = x2 = tmp[2] + tmp[3]*TAN(2)

	;E8T stage - x0 and x2 elements

	movq	mm6,mm3
	paddw	mm3,mm7		;mm3 = e0 = x0+x2
	psubw	mm6,mm7		;mm6 = e3 = x0-x2

	;output butterfly - 0 and 3

	movq	mm7,mm3		;mm7 = e0
	paddw	mm3,mm0		;mm3 = e0 + o0
	psubw	mm7,mm0		;mm7 = e0 - o0
	paddw	mm3,qword ptr round_inv_corr
	paddw	mm7,qword ptr round_inv_corr

	psraw	mm3,SHIFT_INV_COL
	psraw	mm7,SHIFT_INV_COL
	movq	y0,mm3
	movq	y7,mm7

	movq	mm7,mm6		;mm7 = e3 
	paddw	mm6,mm5		;mm6 = e3 + o3
	psubw	mm7,mm5		;mm7 = e3 - o3
	paddw	mm6,qword ptr round_inv_col
	paddw	mm7,qword ptr round_inv_col

	psraw	mm6,SHIFT_INV_COL
	psraw	mm7,SHIFT_INV_COL
	movq	y3,mm6
	movq	y4,mm7

	;B8T stage - x3 element

	movq	mm6,x2		;mm6 = tmp[2]
	pmulhw	mm6,qword ptr tg_2_16	;mm6 = tmp[2] * TAN(2)

	paddw	mm6,mword ptr one_corr

	psubw	mm6,x6		;mm6 = x3 = tmp[2]*TAN(2) - tmp[3]

	;E8T stage - x1 and x3 elements

	movq	mm7,mm4
	paddw	mm4,mm6		;mm4 = e1 = x1+x3
	psubw	mm7,mm6		;mm7 = e2 = x1-x3

	;output butterfly - 1 and 2

	movq	mm6,mm4				;mm6 = e1
	paddw	mm4,mm1				;mm4 = e1 + o1
	psubw	mm6,mm1				;mm4 = e1 - o1
	paddw	mm4,qword ptr round_inv_corr
	paddw	mm6,qword ptr round_inv_corr

	psraw	mm4,SHIFT_INV_COL
	psraw	mm6,SHIFT_INV_COL
	movq	y1,mm4
	movq	y6,mm6

	movq	mm6,mm7				;mm6 = e2
	paddw	mm7,mm2				;mm7 = e2 + o2
	psubw	mm6,mm2				;mm6 = e2 - o2
	paddw	mm7,qword ptr round_inv_col
	paddw	mm6,qword ptr round_inv_col

	psraw	mm7,SHIFT_INV_COL
	psraw	mm6,SHIFT_INV_COL
	movq	y2,mm7
	movq	y5,mm6

	;======= unoptimized code

	ELSE
	movq	mm0,x1		;tmp[4]
	movq	mm1,x7		;tmp[5]
	movq	mm2,x3		;tmp[6]
	movq	mm3,x5		;tmp[7]

	movq	mm4,mm0
	movq	mm5,mm1
	movq	mm6,mm2
	movq	mm7,mm3
	pmulhw	mm4,qword ptr tg_1_16	;tmp[4]*tan(1pi/16)
	pmulhw	mm5,qword ptr tg_1_16	;tmp[5]*tan(1pi/16)
	pmulhw	mm6,qword ptr tg_3_16	;tmp[6]*(tan(3pi/16) - 0.5)
	pmulhw	mm7,qword ptr tg_3_16	;tmp[7]*(tan(3pi/16) - 0.5)

	paddw	mm5,mword ptr one_corr

	paddw	mm6,mm2		;tmp[6]*tan(3pi/16)
	paddw	mm7,mm3		;tmp[7]*tan(3pi/16)
	paddw	mm0,mm5		;mm0 = y0 = tmp[4] + TAN(1)*tmp[5]
	psubw	mm4,mm1		;mm4 = y1 = tmp[4]*TAN(1) - tmp[5]
	paddw	mm2,mm7		;mm2 = y2 = tmp[6] + TAN(3)*tmp[7]
	psubw	mm6,mm3		;mm6 = y3 = tmp[6]*TAN(3) - tmp[7]

	;E8T butterfly - odd elements

	movq	mm1,mm0
	movq	mm5,mm4
	paddw	mm0,mm2		;mm0 = o0 = y0 + y2
	psubw	mm1,mm2		;mm1 = o1 = y0 - y2
	paddw	mm4,mm6		;mm4 = o2 = y1 + y3
	psubw	mm5,mm6		;mm5 = o3 = y1 - y3

	;F8T stage - odd elements

	movq	mm2,mm1
	paddw	mm1,mm4		;mm1 = o1 + o2
	psubw	mm2,mm4		;mm2 = o1 - o2
	movq	mm6,mm1
	movq	mm7,mm2
	pmulhw	mm1,qword ptr cos_4_16
	pmulhw	mm2,qword ptr cos_4_16

	por	mm1,mword ptr one_corr
	psubw	mm2,mword ptr one_corr

	paddw	mm1,mm6		;mm1 = o1' = (o1 + o2)*LAMBDA(4)
	paddw	mm2,mm7		;mm2 = o2' = (o1 - o2)*LAMBDA(4)

	;HOLD these registers:
	;
	;	mm0 = o0
	;	mm1 = o1
	;	mm2 = o2
	;	mm5 = o3

	;EVEN ELEMENTS

	;B8T stage - first two even elements

	movq	mm3,x0		;mm3 = tmp[0]
	movq	mm4,mm3
	paddw	mm3,x4		;mm3 = x0 = tmp[0] + tmp[1]
	psubw	mm4,x4		;mm4 = x1 = tmp[0] - tmp[1]
	
	;B8T stage - x2 element

	movq	mm7,x6		;mm7 = tmp[3]
	pmulhw	mm7,qword ptr tg_2_16	;mm7 = tmp[3] * TAN(2)

	paddw	mm7,mword ptr one_corr

	paddw	mm7,x2		;mm7 = x2 = tmp[2] + tmp[3]*TAN(2)

	;E8T stage - x0 and x2 elements

	movq	mm6,mm3
	paddw	mm3,mm7		;mm3 = e0 = x0+x2
	psubw	mm6,mm7		;mm6 = e3 = x0-x2

	;output butterfly - 0 and 3

	movq	mm7,mm3		;mm7 = e0
	paddw	mm3,mm0		;mm3 = e0 + o0
	psubw	mm7,mm0		;mm7 = e0 - o0
	paddw	mm3,qword ptr round_inv_corr
	paddw	mm7,qword ptr round_inv_corr

	psraw	mm3,SHIFT_INV_COL
	psraw	mm7,SHIFT_INV_COL
	movq	y0,mm3
	movq	y7,mm7

	movq	mm7,mm6		;mm7 = e3 
	paddw	mm6,mm5		;mm6 = e3 + o3
	psubw	mm7,mm5		;mm7 = e3 - o3
	paddw	mm6,qword ptr round_inv_col
	paddw	mm7,qword ptr round_inv_col

	psraw	mm6,SHIFT_INV_COL
	psraw	mm7,SHIFT_INV_COL
	movq	y3,mm6
	movq	y4,mm7

	;B8T stage - x3 element

	movq	mm6,x2		;mm6 = tmp[2]
	pmulhw	mm6,qword ptr tg_2_16	;mm6 = tmp[2] * TAN(2)

	paddw	mm6,mword ptr one_corr

	psubw	mm6,x6		;mm6 = x3 = tmp[2]*TAN(2) - tmp[3]

	;E8T stage - x1 and x3 elements

	movq	mm7,mm4
	paddw	mm4,mm6		;mm4 = e1 = x1+x3
	psubw	mm7,mm6		;mm7 = e2 = x1-x3

	;output butterfly - 1 and 2

	movq	mm6,mm4				;mm6 = e1
	paddw	mm4,mm1				;mm4 = e1 + o1
	psubw	mm6,mm1				;mm4 = e1 - o1
	paddw	mm4,qword ptr round_inv_corr
	paddw	mm6,qword ptr round_inv_corr

	psraw	mm4,SHIFT_INV_COL
	psraw	mm6,SHIFT_INV_COL
	movq	y1,mm4
	movq	y6,mm6

	movq	mm6,mm7				;mm6 = e2
	paddw	mm7,mm2				;mm7 = e2 + o2
	psubw	mm6,mm2				;mm6 = e2 - o2
	paddw	mm7,qword ptr round_inv_col
	paddw	mm6,qword ptr round_inv_col

	psraw	mm7,SHIFT_INV_COL
	psraw	mm6,SHIFT_INV_COL
	movq	y2,mm7
	movq	y5,mm6

	ENDIF
ENDM

	.code

	public _IDCT_mmx

_IDCT_mmx:
	mov	edx,esp
	sub	esp,256
	and	esp,0fffffff8h

	mov	eax,[edx+4]

	DCT_8_INV_ROW_1		eax+0*16, esp+0*16, tab_i_04
	DCT_8_INV_ROW_1		eax+1*16, esp+1*16, tab_i_17
	DCT_8_INV_ROW_1		eax+2*16, esp+2*16, tab_i_26
	DCT_8_INV_ROW_1		eax+3*16, esp+3*16, tab_i_35
	DCT_8_INV_ROW_1		eax+4*16, esp+4*16, tab_i_04
	DCT_8_INV_ROW_1		eax+5*16, esp+5*16, tab_i_35
	DCT_8_INV_ROW_1		eax+6*16, esp+6*16, tab_i_26
	DCT_8_INV_ROW_1		eax+7*16, esp+7*16, tab_i_17
	DCT_8_INV_COL_4		esp+0, esp+8*16
	DCT_8_INV_COL_4		esp+8, esp+8*16+8

	mov	ecx,[edx+8]
	test	dword ptr [edx+16],-1
	jz		inter_start

	mov		eax,-8*16
intra_loop:
	movq		mm0,[esp+eax+16*16]
	movq		mm1,[esp+eax+16*16+8]
	packuswb	mm0,mm1
	movq		[ecx],mm0
	add		ecx,[edx+12]
	add		eax,16
	jne		intra_loop
	mov	esp,edx
	ret

inter_start:
	mov		eax,-8*16
	pxor		mm7,mm7
inter_loop:
	movq		mm0,[esp+eax+16*16]
	movq		mm1,[esp+eax+16*16+8]
	movq		mm2,[ecx]
	movq		mm3,mm2
	punpcklbw	mm2,mm7
	punpckhbw	mm3,mm7
	paddw		mm0,mm2
	paddw		mm1,mm3
	packuswb	mm0,mm1
	movq		[ecx],mm0
	add		ecx,[edx+12]
	add		eax,16
	jne		inter_loop
	mov	esp,edx
	ret

	end
